% RGB_Swarm_Data_Grabber.m
% Written by Sam Bobb, Summer 2009
% Modified from RT_Swarm_Plotter.m

% Use this to plot the values from the RGB sensor of one puck.
% Doesn't work with more than one puck at once. Use the general xbee data
% logger (written in visual c++) to log data from lots of pucks.

% Close any open figures before c%This script will wait for XBee packets and plot the data in them in real
%time.  It expects that teh serial port is already open; run the
%open_serial.m script to open the serial port.  Then run this script.  Hit
%'q' to quit.  After quitting, run the close_serial.m script if you don't
%plan to run the script again.



color_data = zeros(3, 3000);

%avg_period = length(color_data(1,:));

avg_period = 20;

counter = 1;


figure;
%subplot(1,2,1);
hold on;


while (1)
    keypress = keyinfo; %keyinfo.dll written by Fusung Wang from MATLAB Central
    if keypress(1) == 81;
        break;
    end
% 	wait for data
    while(COM.BytesAvailable<100)
        qkeypress = keyinfo; %keyinfo.dll written by Fusung Wang from MATLAB Central
        if keypress(1) == 81
            break;
        end
    end
    [packet ErrorFlag]=getXBeePacket(COM);   
        
    %disp(i);
    %clc;
    %disp(packet.data(11:13)); %%% x,y coordinates (relayed from the vision system)
    %disp(packet.data(16:18)); %%% rgb information from photodiode
    
    % shift color data right
    color_data = circshift(color_data,[0 1]);
    
    color_data(:,1) = packet.data(16:18)';
    
    redavg = sum(color_data(1,1:avg_period))/avg_period;
    greenavg = sum(color_data(2,1:avg_period))/avg_period;
    blueavg = sum(color_data(3,1:avg_period))/avg_period;
    clc
    fprintf( 'R avg: %4.2f Std: %4.2f \n', redavg, std(color_data(1,1:avg_period)) )
    fprintf( 'G avg: %4.2f Std: %4.2f \n', greenavg, std(color_data(2,1:avg_period)) )
    fprintf( 'B avg: %4.2f Std: %4.2f \n', blueavg, std(color_data(3,1:avg_period)) )
    
    clf('reset');
    
    
    set(gca,'ColorOrder',[1 0 0; 0 1 0; 0 0 1],'NextPlot','ReplaceChildren')
    
    plot(color_data(:,1:counter)');
    drawnow;
    
    if counter < length(color_data)
        counter = counter + 1;
    end
    
    

    
    
    if (COM.BytesAvailable>2000)
        fread(COM, COM.BytesAvailable);
        disp('Buffer Flushed');
    end
end  %while(1)

% fclose(COM)
% delete(COM)
% clear COM