% ID    Name    Function                                                Usage                                   Example
% 1     sleep 	stop moving and stop sending data.                      sleep <ID>                              sleep 0
% 2     wake 	wake from sleep and resume                              wake <ID>                               wake 0
% 3     goal 	Change the swarm's goal state.                          goal <ID> <Ix> <Iy> <Ixx> <Ixy> <Iyy> 	goal 0 100 300 160000 40000 40000
% 4     goto 	only changes <Ix> and <Iy>.                             goto <ID> <Ix> <Iy>                     goto 0 100 300
% 5     deadb 	Change the robot motor deadband.                        deadb <ID> <velocity>                   deadb 0 150
% 6     egain 	Change the estimator gains.                             egain <ID> <KP> <KI> <Gamma>            egain 0 0.7 0.1 0.05
% 7     cgain 	Change the motion controller gains.                     cgain <ID> <KIx> <KIy> <KIxx> <KIxy> <KIyy> 	cgain 0 2 2 0.001 0.001 0.001
% 8     commr 	Change the communication radius distance.               commr <ID> <distance>                   commr 0 1500
% 9     speed 	Change the maximum allowed speed for the robot.         speed <ID> <speed>                      speed 0 300
% 10    safed 	Change the obstacle avoidance threshold.                speed <ID> <distance>                   safed 0 200
A=zeros(90,1);
A(1)=1; % ID
A(2)=500;
A(3)=500;
%A(4)=180*pi/180;

destination = uint8(0); % destination indicates which epuck will receive the command. 0 means broadcast.

clear sendComm
sendComm=assemblePacket(single(A));
fwrite(COM,sendComm,'uint8');
disp('done');